# coding: utf-8

"""
    Montelo

    Documentation for the Montelo API.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictStr
from pydantic import Field
from montelo.client.openapi_client.models.datapoint_dto import DatapointDto
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class FullDatasetDto(BaseModel):
    """
    FullDatasetDto
    """ # noqa: E501
    id: StrictStr
    env_id: StrictStr = Field(alias="envId")
    name: StrictStr
    description: Optional[StrictStr] = None
    is_generating: StrictBool = Field(alias="isGenerating")
    datapoints: List[DatapointDto]
    __properties: ClassVar[List[str]] = ["id", "envId", "name", "description", "isGenerating", "datapoints"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of FullDatasetDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in datapoints (list)
        _items = []
        if self.datapoints:
            for _item in self.datapoints:
                if _item:
                    _items.append(_item.to_dict())
            _dict['datapoints'] = _items
        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of FullDatasetDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "envId": obj.get("envId"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "isGenerating": obj.get("isGenerating"),
            "datapoints": [DatapointDto.from_dict(_item) for _item in obj.get("datapoints")] if obj.get("datapoints") is not None else None
        })
        return _obj


