# coding: utf-8

"""
    Montelo

    Documentation for the Montelo API.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ProjectDto(BaseModel):
    """
    ProjectDto
    """ # noqa: E501
    id: StrictStr
    name: StrictStr
    org_id: Optional[StrictStr] = Field(default=None, alias="orgId")
    user_id: Optional[StrictStr] = Field(default=None, alias="userId")
    openai_api_key: Optional[StrictStr] = Field(alias="openaiApiKey")
    cohere_api_key: Optional[StrictStr] = Field(alias="cohereApiKey")
    __properties: ClassVar[List[str]] = ["id", "name", "orgId", "userId", "openaiApiKey", "cohereApiKey"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ProjectDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # set to None if openai_api_key (nullable) is None
        # and model_fields_set contains the field
        if self.openai_api_key is None and "openai_api_key" in self.model_fields_set:
            _dict['openaiApiKey'] = None

        # set to None if cohere_api_key (nullable) is None
        # and model_fields_set contains the field
        if self.cohere_api_key is None and "cohere_api_key" in self.model_fields_set:
            _dict['cohereApiKey'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ProjectDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "orgId": obj.get("orgId"),
            "userId": obj.get("userId"),
            "openaiApiKey": obj.get("openaiApiKey"),
            "cohereApiKey": obj.get("cohereApiKey")
        })
        return _obj


